****************************************************************************
* Project:	ultraSTE
* Module:	defines
* Code:		ultra
* Created:	11.04.2021
* Notes:	
* Modified:
* Changes:
*
* (c) 2021 cream
****************************************************************************
;//USRegSelect		equ		$ffff827c	;fffffc3c
;//USRegData		equ		$ffff827e	;fffffc3e
USRegRestore		equ		$fffffc38
USRegSelect		equ		$fffffc3a
USRegData		equ		$fffffc3c
USRegData2		equ		$fffffc3e	;same as USRegData only used for .l accesses

* register defines
USCounterXR	equ	$0000
USCounterYR	equ	$0001
USC2pHStartR	equ	$0002
USC2pHEndR	equ	$0003
USC2pShift	equ	$0004	;no effect on steem... do not write to this register
USC2pVEndR	equ	$0005	;not implemented yet
USDisplayModeR	equ	$0006
USFadeToBlack1R	equ	$0007
USFadeToWhiteR	equ	$0008
USObjMemRdPos	equ	$0009
USObjMemData	equ	$000a
USSetFake1x2R	equ	$000b
USFadeToBlack2R	equ	$000c
;// layer 3
USLayer3Options equ	$000d

;// options values
USLayer3OptEnable	equ (%01)
USLayer3OptAdd 		equ (%00<<2)	;how layer3 is added to the output
USLayer3OptSub 		equ (%01<<2)
USLayer3OptOvr 		equ (%10<<2)
USLayer3OptXor 		equ (%11<<2)
USLayer3OptMirrowX 	equ (%1<<4)
USLayer3OptMirrowY 	equ (%1<<5)
USLayer3OptRepeat 	equ (%1<<8)
USLayer3OptScaleX1 	equ (%000<<10)	;x scale
USLayer3OptScaleX2 	equ (%001<<10)
USLayer3OptScaleX4 	equ (%010<<10)
USLayer3OptScaleX8 	equ (%011<<10)
USLayer3OptScaleX16 	equ (%100<<10)
USLayer3OptScaleX32	equ (%101<<10)
USLayer3OptScaleX64	equ (%110<<10)
USLayer3OptScaleX128 	equ (%111<<10)
USLayer3OptScaleY1 	equ (%000<<13)	;y scale
USLayer3OptScaleY2 	equ (%001<<13)
USLayer3OptScaleY4 	equ (%010<<13)
USLayer3OptScaleY8 	equ (%011<<13)
USLayer3OptScaleY16 	equ (%100<<13)
USLayer3OptScaleY32	equ (%101<<13)
USLayer3OptScaleY64	equ (%110<<13)
USLayer3OptScaleY128 	equ (%111<<13)
USLayer3OptScaleXY1 	equ (%000<<10)|(%000<<13)	;combined x&y scale
USLayer3OptScaleXY2 	equ (%001<<10)|(%001<<13)
USLayer3OptScaleXY4 	equ (%010<<10)|(%010<<13)
USLayer3OptScaleXY8 	equ (%011<<10)|(%011<<13)
USLayer3OptScaleXY16 	equ (%100<<10)|(%100<<13)
USLayer3OptScaleXY32	equ (%101<<10)|(%101<<13)
USLayer3OptScaleXY64	equ (%110<<10)|(%110<<13)
USLayer3OptScaleXY128 	equ (%111<<10)|(%111<<13)

USFadeToBlack3	equ	$000e
USLayer3XPos	equ	$000f
USLayer3YPos	equ	$0010
USLayer3XSize	equ	$0011
USLayer3YSize	equ	$0012
USLayer3MemOffset equ	$0013

USSetLayer3Adr	equ	$0014
USSDisplayShift	equ	$0015

USMinX		equ 	$0016
USMaxX		equ 	$0017
USMinY		equ 	$0018
USMaxY		equ 	$0019


USColorTable1R	equ	$100
USColorTable2R	equ	$300
USColorTable3R	equ	$500
USColorTable4R	equ	$700

* 3d stuff
US3dWrCamMatrixR	equ	$1000
US3dWrCamPosR		equ	$1001

US3dWrObj1MatrixR	equ	$1002
US3dWrObj2MatrixR	equ	$1003
US3dWrObj3MatrixR	equ	$1004
US3dWrObj4MatrixR	equ	$1005
US3dWrObj5MatrixR	equ	$1006
US3dWrObj6MatrixR	equ	$1007
US3dWrObj7MatrixR	equ	$1008
US3dWrObj8MatrixR	equ	$1009
US3dWrObj9MatrixR	equ	$100a
US3dWrObj10MatrixR	equ	$100b
US3dWrObj11MatrixR	equ	$100c
US3dWrObj12MatrixR	equ	$100d
US3dWrObj13MatrixR	equ	$100e
US3dWrObj14MatrixR	equ	$100f
US3dWrObj15MatrixR	equ	$1010
US3dWrObj16MatrixR	equ	$1011

US3dWrObj1PosR		equ	$1012
US3dWrObj2PosR		equ	$1013
US3dWrObj3PosR		equ	$1014
US3dWrObj4PosR		equ	$1015
US3dWrObj5PosR		equ	$1016
US3dWrObj6PosR		equ	$1017
US3dWrObj7PosR		equ	$1018
US3dWrObj8PosR		equ	$1019
US3dWrObj9PosR		equ	$101a
US3dWrObj10PosR		equ	$101b
US3dWrObj11PosR		equ	$101c
US3dWrObj12PosR		equ	$101d
US3dWrObj13PosR		equ	$101e
US3dWrObj14PosR		equ	$101f
US3dWrObj15PosR		equ	$1020
US3dWrObj16PosR		equ	$1021

US3dWrObjectListR	equ	$1022
US3dWrObjectDataR	equ	$1023

US3dWrObj1RotOfsR	equ	$1026
US3dWrObj2RotOfsR	equ	$1027
US3dWrObj3RotOfsR	equ	$1028
US3dWrObj4RotOfsR	equ	$1029
US3dWrObj5RotOfsR	equ	$102a
US3dWrObj6RotOfsR	equ	$102b
US3dWrObj7RotOfsR	equ	$102c
US3dWrObj8RotOfsR	equ	$102d
US3dWrObj9RotOfsR	equ	$102e
US3dWrObj10RotOfsR	equ	$102f
US3dWrObj11RotOfsR	equ	$1030
US3dWrObj12RotOfsR	equ	$1031
US3dWrObj13RotOfsR	equ	$1032
US3dWrObj14RotOfsR	equ	$1033
US3dWrObj15RotOfsR	equ	$1034
US3dWrObj16RotOfsR	equ	$1035

US3dStartCalcR		equ	$1101
US3dBusyCalcR		equ	$1102

US3dEnvMemLocR		equ	$1103
US3dFaceMemLocR		equ	$1104
US3dFaceSortMemLocR	equ	$1105
US3dVisibleFacesR	equ	$1106
US3dCalcFaceDataR	equ	$1107
US3dSelectFaceR		equ	$1108
US3dGetFaceR		equ	$1109

US3dRdVertex		equ	$110a
US3dRdEnv		equ	$110b
US3dRdFace		equ	$110c
US3dRdFaceList		equ	$110d
US3dScreenX		equ	$110e
US3dScreenY		equ	$110f
US3dCalcLineData	equ	$1110
US3dGetLineData		equ 	$1111
US3dLineScreenAdrHi	equ 	$1113
US3dLineScreenAdrLo	equ 	$1114
US3dLineBytesPerLine	equ 	$1115

US3dResultData		equ	$d00000
*******************************************************************************
	rsreset
	; in atari mem
US3dObjListPointOffset	rs.l	1
US3dObjListEnvOffset	rs.l	1
US3dObjListFaceOffset	rs.l	1
US3dObjListOriginX	rs.w	1
US3dObjListOriginY	rs.w	1
US3dObjListOriginZ	rs.w	1

US3dObjListEntryLen	equ	18
US3dObjListEntryFPGALen	equ	4*2

USSelReg macro 
	move	#\1,USRegSelect
	endm

USWrReg	macro
	move	#\2,USRegSelect
	move	\1,USRegData
	endm

USRdReg macro
	move	#\1,USRegSelect
	move	USRegData, \2
	endm

USWrData macro
	move	\1,USRegData
	endm

;//	macro USWrData
;//	move	USRegData,\1
;//	endm
	
US3dWriteMatrix macro
	lea	USRegData.w,a1
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	endm

US3dWriteVec macro
	lea	USRegData.w,a1
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	move	(a0)+,(a1)
	endm
